#!/bin/bash

# source package is here : ftp://ftp.cistron.nl/pub/people/miquels/sysvinit/
# Packager : JP <jp.guillemin@free.fr>

soft='sysvinit'
softversion='2.86'
packageversion='70.2'

arch='i486'
cpu='i686'

buildir=$(pwd)
srcpkg="$buildir/$soft-$softversion.tar.gz"
src="$buildir/$soft-$softversion"
package="$soft-$softversion-$arch-$packageversion"
dest="/tmp/$package"

cd $buildir
rm -rf $src
tar -xvf $srcpkg
rm -f $dest.tgz
rm -rf $dest
mkdir -p $dest
chown -R root:root .
export CFLAGS="-O2 -march=$arch -mtune=$cpu"

# We copy the package skeleton
cp -rpf $buildir/skel/* $dest/

# Now we build INIT
cd $src
patch -p1 < $buildir/zenwalk-sysvinit.patch
cd doc
mkdir -p $dest/usr/doc/sysvinit-$softversion
cp -a Install Propaganda sysvinit-$softversion.lsm \
  $dest/usr/doc/sysvinit-$softversion
chmod -R 644 $dest/usr/doc/sysvinit-$softversion/*
chmod 755 $dest/usr/doc/sysvinit-$softversion
cd $src/src
make clobber
make

# Strip tease

for program in halt init killall5 shutdown runlevel ; do
  strip $program
  cp -f $program $dest/sbin/
done

strip last
cp -f last $dest/usr/bin/

chmod 755 $dest/sbin/*
chmod 755 $dest/usr/bin/*

cp initscript.sample $dest/sbin/initscript.sample

# Take care of man pages

cd $src/man
cat last.1 | gzip -9c > $dest/usr/man/man1/last.1.gz
for page in inittab.5 initscript.5 ; do
  cat $page | gzip -9c > $dest/usr/man/man5/$page.gz
done
for page in halt.8 init.8 killall5.8 pidof.8 poweroff.8 reboot.8 runlevel.8 \
  shutdown.8 telinit.8 ; do
  cat $page | gzip -9c > $dest/usr/man/man8/$page.gz
done


# Install directory (slack-desc and co)
mkdir -p $dest/install
cat > $dest/install/slack-desc << END
sysvinit: sysvinit (init, the parent of all processes)
sysvinit:
sysvinit: System V style init programs by Miquel van Smoorenburg that control
sysvinit: the booting and shutdown of your system.  These support a number of
sysvinit: system runlevels, each with a specific set of utilities spawned.
sysvinit: For example, the normal system runlevel is 3, which starts agetty
sysvinit: on virtual consoles tty1 - tty6.  Runlevel 4 starts X window.
sysvinit: Runlevel 0 shuts the system down.
sysvinit:
sysvinit:
sysvinit:
END


# I go home ;)
mkdir -p $dest/usr/src/$soft-$softversion
( cd $buildir
cp -a *.patch $dest/usr/src/$soft-$softversion/
cp -a build-$soft.sh $dest/usr/src/$soft-$softversion/
)

cd $dest
makepkg -l y -c n $dest.txz

# cleanup
rm -rf $dest
rm -rf $src
